#!/usr/bin/perl

$certsdir = shift;
$hostcert = shift;
$edgconfig = shift;
$output = shift;

# Find all of the installed signing policy files.
opendir CERTS, $certsdir;
@allfiles = grep /.*\.signing_policy$/, readdir CERTS;
closedir CERTS;

# Pull out the conditional subjects in each file. 
$subjects = "";
foreach $file (@allfiles) {

    open FILE, "<$certsdir/$file";
    while (<FILE>) {
	chomp;
	if ($_ =~ m/cond_subjects.*\'(.+)\'.*/) {
	    $subjects .= " $1 ";
	}
    }
    close FILE;
}

# Strip off the leading and trailing quotation marks.
$subjects =~ /.*?\"(.+)\".*?/;
$subjects = $1;
@entries = split /\".*?\"/, $subjects;

# Now generate the output file.
$config = "";
foreach $entry (@entries) {
    $config .= "accepted_credentials \"$entry\"\n";
}

# The subject names of the related resource brokers are
# needed.  Pull these out of the provided configuration
# file.
open FILE, "<$edgconfig";
while (<FILE>) {
    chomp;
    if (!($_ =~ m/^\#.*/) && !($_ =~ m/^\s*$/)) {
	$config .= "authorized_renewers \"$_\"\n";
    }
}
close FILE;

# Write out the file.
open CONFIG, ">$output";
print CONFIG $config;
close CONFIG;

exit;

